
#pragma once
//{ZpNX

#define MP_RADIXBIT 31
#define MP_RADIX (1U << MP_RADIXBIT)
#define MP_MASK (MP_RADIX - 1)
#define MP_PLACE10 9
#define MP_DIVISOR10 1000000000
#define MP_INVALID 0x00000000
#define MP_EQUAL 0x00000001
#define MP_GREATER 0x00000002
#define MP_LESS 0x00000004

//0(2^MP_RADIXBIT-2^((1-x)*MP_RADIXBIT))܂ł̑{Œ菬_
class CMultiplePrecision
{
protected:
	DWORD* m_pData;
	DWORD m_Length;
public:
	CMultiplePrecision()
	{
		m_pData = NULL;
		m_Length = 0;
	}
	CMultiplePrecision(DWORD x)
	{
		m_pData = new DWORD[1];
		m_Length = 1;
		m_pData[0] = x;
	}
	CMultiplePrecision(DOUBLE x)
	{
		m_pData = new DWORD[32];
		m_Length = 32;
		*this = x;
	}
	CMultiplePrecision(CMultiplePrecision& x)
	{
		m_pData = new DWORD[x.m_Length];
		m_Length = x.m_Length;
		memcpy(m_pData, x.m_pData, sizeof(DWORD) * m_Length);
	}
	~CMultiplePrecision()
	{
		Destroy();
	}
	void Create(DWORD Length)
	{
		Destroy();
		m_pData = new DWORD[Length];
		m_Length = Length;
		memset(m_pData, 0, sizeof(DWORD) * Length);
	}
	void Destroy()
	{
		if(m_pData)
			delete []m_pData;
		m_pData = NULL;
		m_Length = 0;
	}
	void SetLength(DWORD Length)
	{
		DWORD* p;
		DWORD i;
		if(!m_pData)
		{
			Create(Length);
			return;
		}
		p = m_pData;
		i = m_Length;
		m_pData = new DWORD[Length];
		m_Length = Length;
		if(Length < i)
			memcpy(m_pData, p, sizeof(DWORD) * Length);
		else
		{
			memcpy(m_pData, p, sizeof(DWORD) * i);
			memset(&m_pData[i], 0, sizeof(DWORD) * (Length - i));
		}
		delete []p;
	}
	void Duplicate(CMultiplePrecision& x)
	{
		Create(x.m_Length);
		memcpy(m_pData, x.m_pData, sizeof(DWORD) * m_Length);
	}
	DWORD GetDword()
	{
		if(m_Length > 0)
			return m_pData[0];
		return 0;
	}
	DOUBLE GetDouble()
	{
		DWORD i;
		DWORD* p;
		DOUBLE d;
		DOUBLE e;
		DOUBLE f;
		i = 0;
		p = &m_pData[i];
		d = 0.0;
		e = 1.0;
		while(i < m_Length)
		{
			f = *p * e;
			if((*p != 0 && d + f == d) || f == 0.0)
				break;
			d += f;
			e /= MP_RADIX;
			i++;
			p++;
		}
		return d;
	}
	DWORD Compare(CMultiplePrecision& x)
	{
		DWORD i;
		DWORD* p;
		DWORD* px;
		if(!m_pData)
			return MP_INVALID;
		if(!x.m_pData)
			return MP_INVALID;
		if(m_Length > x.m_Length)
		{
			i = 0;
			p = &m_pData[i];
			px = &x.m_pData[i];
			while(i < x.m_Length)
			{
				if(*p > *px)
					return MP_GREATER;
				else if(*p < *px)
					return MP_LESS;
				i++;
				p++;
				px++;
			}
			while(i < m_Length)
			{
				if(*p != 0)
					return MP_GREATER;
				i++;
				p++;
			}
		}
		else
		{
			i = 0;
			p = &m_pData[i];
			px = &x.m_pData[i];
			while(i < m_Length)
			{
				if(*p > *px)
					return MP_GREATER;
				else if(*p < *px)
					return MP_LESS;
				i++;
				p++;
				px++;
			}
			while(i < x.m_Length)
			{
				if(*p != 0)
					return MP_LESS;
				i++;
				p++;
			}
		}
		return MP_EQUAL;
	}
	BOOL IsZero()
	{
		DWORD i;
		DWORD* p;
		if(!m_pData)
			return FALSE;
		i = 0;
		p = &m_pData[i];
		while(i < m_Length)
		{
			if(*p != 0)
				return FALSE;
			i++;
			p++;
		}
		return TRUE;
	}
	BOOL IsInteger()
	{
		DWORD i;
		DWORD* p;
		if(!m_pData)
			return FALSE;
		i = 1;
		p = &m_pData[i];
		while(i < m_Length)
		{
			if(*p != 0)
				return FALSE;
			i++;
			p++;
		}
		return TRUE;
	}
	void SubstituteEpsilon()
	{
		memset(m_pData, 0, sizeof(DWORD) * m_Length);
		if(m_Length > 0)
			m_pData[m_Length - 1] = 1;
	}
	DWORD Div(DWORD m, DWORD x)
	{
		DWORD i;
		ULONGLONG j;
		DWORD* p;
		i = m;
		j = 0;
		p = &m_pData[i];
		while(i < m_Length)
		{
			j = (j << MP_RADIXBIT) + *p;
			*p = (DWORD)(j / x);
			j -= (ULONGLONG)*p * x;
			i++;
			p++;
		}
		if(m_pData[m] == 0)
			return m + 1;
		return m;
	}
	void ShiftLeft(DWORD x)
	{
		DWORD i;
		DWORD j;
		DWORD k;
		ULONGLONG l;
		DWORD* p;
		DWORD* pn;
		if(x / MP_RADIXBIT >= m_Length)
		{
			memset(m_pData, 0, sizeof(DWORD) * m_Length);
			return;
		}
		j = x / MP_RADIXBIT;
		k = m_Length - j;
		if(j > 0)
		{
			i = 0;
			p = &m_pData[i];
			pn = &m_pData[j];
			while(i < k)
			{
				*p = *pn;
				i++;
				p++;
				pn++;
			}
		}
		x -= j * MP_RADIXBIT;
		i = k;
		l = 0;
		p = &m_pData[i];
		while(i > 0)
		{
			i--;
			p--;
			l += (ULONGLONG)*p << x;
			*p = (DWORD)l & MP_MASK;
			l = l >> MP_RADIXBIT;
		}
		memset(&m_pData[k], 0, sizeof(DWORD) * j);
	}
	void ShiftRight(DWORD x)
	{
		DWORD i;
		DWORD j;
		DWORD k;
		ULONGLONG l;
		DWORD* p;
		DWORD* pn;
		if(x / MP_RADIXBIT >= m_Length)
		{
			memset(m_pData, 0, sizeof(DWORD) * m_Length);
			return;
		}
		j = x / MP_RADIXBIT;
		k = m_Length - j;
		if(j > 0)
		{
			i = k;
			p = &m_pData[i + j];
			pn = &m_pData[i];
			while(i > 0)
			{
				i--;
				p--;
				pn--;
				*p = *pn;
			}
		}
		x -= j * MP_RADIXBIT;
		i = 0;
		l = 0;
		p = &m_pData[i];
		while(i < k)
		{
			l += (ULONGLONG)*p << (MP_RADIXBIT - x);
			*p = (DWORD)(l >> MP_RADIXBIT) & MP_MASK;
			l = l << MP_RADIXBIT;
			i++;
			p++;
		}
		memset(m_pData, 0, sizeof(DWORD) * j);
	}
	BOOL Print(TCHAR* String)
	{
		DWORD i;
		CMultiplePrecision x(*this);
		if(m_Length == 0)
			return FALSE;
		String = PrintInteger(String, x.m_pData[0], 10, 1);
		if(m_Length > 1)
		{
			*String = '.';
			String++;
			for(i = 1; i < m_Length; i++)
			{
				x.m_pData[0] = 0;
				x *= MP_DIVISOR10;
				String = PrintInteger(String, x.m_pData[0], 10, MP_PLACE10);
			}
		}
		*String = '\0';
		return TRUE;
	}
	BOOL Scan(LPCTSTR String)
	{
		DWORD i;
		CMultiplePrecision a;
		CMultiplePrecision b;
		if(m_Length == 0)
			return FALSE;
		a.Create(m_Length);
		b.Create(m_Length);
		memset(m_pData, 0, sizeof(DWORD) * m_Length);
		String = ScanInteger(String, &m_pData[0], MP_PLACE10 + 1, FALSE);
		if(*String != '.')
			return TRUE;
		String++;
		a.m_pData[0] = 1;
		while(*String != '\0')
		{
			String = ScanInteger(String, &i, MP_PLACE10, TRUE);
			b = a;
			b *= i;
			b /= MP_DIVISOR10;
			*this += b;
			a /= MP_DIVISOR10;
			if(a.IsZero())
				break;
		}
		return TRUE;
	}
/*	operator DWORD()
	{
		if(m_Length > 0)
			return m_pData[0];
		return 0;
	}
	operator DOUBLE()
	{
		DWORD i;
		DWORD* p;
		DOUBLE d;
		DOUBLE e;
		DOUBLE f;
		i = 0;
		p = &m_pData[i];
		d = 0.0;
		e = 1.0;
		while(i < m_Length)
		{
			f = *p * e;
			if((*p != 0 && d + f == d) || f == 0.0)
				break;
			d += f;
			e /= MP_RADIX;
			i++;
			p++;
		}
		return d;
	}*/
	void operator=(DWORD x)
	{
		memset(m_pData, 0, sizeof(DWORD) * m_Length);
		if(m_Length > 0)
			m_pData[0] = x;
	}
	void operator=(DOUBLE x)
	{
		DWORD i;
		DWORD* p;
		DOUBLE d;
		DOUBLE e;
		memset(m_pData, 0, sizeof(DWORD) * m_Length);
		i = 0;
		p = &m_pData[i];
		e = 1.0;
		while(i < m_Length)
		{
			d = fmod(x, e * MP_RADIX);
			*p = (DWORD)(d / e);
			x -= *p * e;
			if(x == 0.0)
				break;
			e /= MP_RADIX;
			i++;
			p++;
		}
	}
	void operator=(CMultiplePrecision& x)
	{
		if(m_Length < x.m_Length)
			memcpy(m_pData, x.m_pData, sizeof(DWORD) * m_Length);
		else
		{
			memcpy(m_pData, x.m_pData, sizeof(DWORD) * x.m_Length);
			memset(&m_pData[x.m_Length], 0, sizeof(DWORD) * (m_Length - x.m_Length));
		}
	}
	CMultiplePrecision operator+(DWORD x)
	{
		CMultiplePrecision xp(*this);
		xp += x;
		return xp;
	}
	CMultiplePrecision operator+(DOUBLE x)
	{
		CMultiplePrecision xp(*this);
		xp += (CMultiplePrecision)x;
		return xp;
	}
	CMultiplePrecision operator+(CMultiplePrecision& x)
	{
		CMultiplePrecision xp(*this);
		xp += x;
		return xp;
	}
	CMultiplePrecision operator-(DWORD x)
	{
		CMultiplePrecision xp(*this);
		xp -= x;
		return xp;
	}
	CMultiplePrecision operator-(DOUBLE x)
	{
		CMultiplePrecision xp(*this);
		xp -= (CMultiplePrecision)x;
		return xp;
	}
	CMultiplePrecision operator-(CMultiplePrecision& x)
	{
		CMultiplePrecision xp(*this);
		xp -= x;
		return xp;
	}
	CMultiplePrecision operator*(DWORD x)
	{
		CMultiplePrecision xp(*this);
		xp *= x;
		return xp;
	}
	CMultiplePrecision operator*(DOUBLE x)
	{
		CMultiplePrecision xp(*this);
		xp *= (CMultiplePrecision)x;
		return xp;
	}
	CMultiplePrecision operator*(CMultiplePrecision& x)
	{
		CMultiplePrecision xp(*this);
		xp *= x;
		return xp;
	}
	CMultiplePrecision operator/(DWORD x)
	{
		CMultiplePrecision xp(*this);
		xp /= x;
		return xp;
	}
	CMultiplePrecision operator/(CMultiplePrecision& x)
	{
		CMultiplePrecision xp(*this);
		xp /= x;
		return xp;
	}
	void operator+=(DWORD x)
	{
		if(m_Length > 0)
			m_pData[0] += x;
	}
	void operator+=(CMultiplePrecision& x)
	{
		DWORD i;
		DWORD j;
		DWORD* p;
		DWORD* px;
		if(m_Length < x.m_Length)
			i = m_Length;
		else
			i = x.m_Length;
		j = 0;
		p = &m_pData[i];
		px = &x.m_pData[i];
		while(i > 0)
		{
			i--;
			p--;
			px--;
			j += *p + *px;
			*p = j & MP_MASK;
			j = j >> MP_RADIXBIT;
		}
	}
	void operator-=(DWORD x)
	{
		if(m_Length > 0)
			m_pData[0] -= x;
	}
	void operator-=(CMultiplePrecision& x)
	{
		DWORD i;
		DWORD j;
		DWORD* p;
		DWORD* px;
		if(m_Length < x.m_Length)
			i = m_Length;
		else
			i = x.m_Length;
		j = 0;
		p = &m_pData[i];
		px = &x.m_pData[i];
		while(i > 0)
		{
			i--;
			p--;
			px--;
			j = *p - *px - j;
			*p = j & MP_MASK;
			j = (j & MP_RADIX) >> MP_RADIXBIT;
		}
	}
	void operator*=(DWORD x)
	{
		DWORD i;
		ULONGLONG j;
		DWORD* p;
		i = m_Length;
		j = 0;
		p = &m_pData[i];
		while(i > 0)
		{
			i--;
			p--;
			j += (ULONGLONG)*p * x;
			*p = (DWORD)j & MP_MASK;
			j = j >> MP_RADIXBIT;
		}
	}
	void operator*=(CMultiplePrecision& x)
	{
		DWORD i;
		DWORD j;
		ULONGLONG k;
		DWORD* p;
		DWORD* px;
		DWORD* pxp;
		CMultiplePrecision xp(*this);
		Create(x.m_Length + xp.m_Length - 1);
		i = x.m_Length;
		px = &x.m_pData[i];
		while(i > 0)
		{
			i--;
			px--;
			j = xp.m_Length;
			k = 0;
			p = &m_pData[i + j];
			pxp = &xp.m_pData[j];
			while(j > 0)
			{
				j--;
				p--;
				pxp--;
				k += (ULONGLONG)*pxp * *px;
				*p += (DWORD)k & MP_MASK;
				k = (k >> MP_RADIXBIT) + (*p >> MP_RADIXBIT);
				*p &= MP_MASK;
			}
			if(i > 0)
			{
				p--;
				*p += (DWORD)k & MP_MASK;
			}
		}
	}
	void operator/=(DWORD x)
	{
		DWORD i;
		ULONGLONG j;
		DWORD* p;
		i = 0;
		j = 0;
		p = &m_pData[i];
		while(i < m_Length)
		{
			j = (j << MP_RADIXBIT) + *p;
			*p = (DWORD)(j / x);
			j -= (ULONGLONG)*p * x;
			i++;
			p++;
		}
	}
	void operator/=(CMultiplePrecision& x)
	{
		DWORD i;
		DWORD j;
		DWORD k;
		DWORD l;
		DWORD m;
		ULONGLONG n;
		DWORD* p;
		DWORD* pxp;
		CMultiplePrecision xp(*this);
		CMultiplePrecision a(x);
		CMultiplePrecision b;
		b.Create(x.m_Length);
		memset(m_pData, 0, sizeof(DWORD) * m_Length);
		i = 0;
		j = 0;
		p = &a.m_pData[i];
		while(i < a.m_Length)
		{
			if(*p > 0)
				break;
			i++;
			p++;
		}
		if(i == a.m_Length)
			return;
		while(j < MP_RADIXBIT)
		{
			if((*p << j) & (MP_RADIX >> 1))
				break;
			j++;
		}
		i = i * MP_RADIXBIT + j;
		j = 0;
		k = 0;
		p = &xp.m_pData[j];
		while(j < xp.m_Length)
		{
			if(*p > 0)
				break;
			j++;
			p++;
		}
		if(j == xp.m_Length)
			return;
		while(k < MP_RADIXBIT)
		{
			if((*p << k) & (MP_RADIX >> 1))
				break;
			k++;
		}
		j = j * MP_RADIXBIT + k;
		if(i > 0)
			a.ShiftLeft(i);
		if(j > 0)
			xp.ShiftLeft(j);
		k = 0;
		l = a.m_pData[0];
		n = 0;
		p = &m_pData[k];
		pxp = &xp.m_pData[k];
		while(k < xp.m_Length)
		{
			if(xp.IsZero())
				break;
			if(a.IsZero())
				break;
			n += *pxp;
			m = (DWORD)(n / l);
			if(m > 0)
			{
				b = a;
				b *= m;
				if(b > xp)
				{
					m--;
					b -= a;
					if(b > xp)
					{
						m--;
						b -= a;
					}
				}
				xp -= b;
				n = *pxp;
			}
			a /= MP_RADIX;
			n = n << MP_RADIXBIT;
			*p = m;
			k++;
			p++;
			pxp++;
		}
		if(i > j)
			ShiftLeft(i - j);
		else if(i < j)
			ShiftRight(j - i);
	}
	BOOL operator==(CMultiplePrecision& x)
	{
		if(Compare(x) & MP_EQUAL)
			return TRUE;
		return FALSE;
	}
	BOOL operator!=(CMultiplePrecision& x)
	{
		if(Compare(x) & MP_EQUAL)
			return FALSE;
		return TRUE;
	}
	BOOL operator>(CMultiplePrecision& x)
	{
		if(Compare(x) & MP_GREATER)
			return TRUE;
		return FALSE;
	}
	BOOL operator<(CMultiplePrecision& x)
	{
		if(Compare(x) & MP_LESS)
			return TRUE;
		return FALSE;
	}
	BOOL operator>=(CMultiplePrecision& x)
	{
		if(Compare(x) & (MP_EQUAL | MP_GREATER))
			return TRUE;
		return FALSE;
	}
	BOOL operator<=(CMultiplePrecision& x)
	{
		if(Compare(x) & (MP_EQUAL | MP_LESS))
			return TRUE;
		return FALSE;
	}
protected:
	TCHAR* PrintInteger(TCHAR* String, DWORD x, DWORD Radix, DWORD Padding)
	{
		TCHAR s[32];
		DWORD i;
		i = 0;
		while(x > 0)
		{
			s[i] = (TCHAR)((x % Radix) + '0');
			x /= Radix;
			i++;
		}
		while(i < Padding)
		{
			s[i] = '0';
			i++;
		}
		while(i > 0)
		{
			i--;
			*String = s[i];
			String++;
		}
		return String;
	}
	LPCTSTR ScanInteger(LPCTSTR String, DWORD* px, DWORD Count, BOOL bPoint)
	{
		DWORD i;
		i = 0;
		*px = 0;
		if(bPoint)
		{
			while(i < Count)
			{
				*px *= 10;
				if(_istdigit(*String))
				{
					*px += *String - '0';
					String++;
				}
				i++;
			}
		}
		else
		{
			while(i < Count && _istdigit(*String))
			{
				*px *= 10;
				*px += *String - '0';
				i++;
				String++;
			}
		}
		return String;
	}
};

